﻿using System;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace IGDocumentation
{
    public class CarsBusinessLogic
    {
        public ObservableCollection<Car> GetCars()
        {
            ObservableCollection<Car> carList = new ObservableCollection<Car>();
            carList.Add(new Car("Dodge", new DateTime(2014, 2, 1, 11, 30, 20), new DateTime(2014, 2, 1, 11, 30, 20), new DateTime(2019, 7, 1, 1, 30, 20)));
            carList.Add(new Car("Ford", new DateTime(2016, 4, 1, 14, 30, 20), new DateTime(2017, 3, 1, 14, 30, 20), new DateTime(2014, 8, 1, 21, 30, 20)));
            carList.Add(new Car("BMW", new DateTime(2018, 1, 1, 17, 30, 20), new DateTime(2014, 4, 1, 17, 30, 20), new DateTime(2015, 9, 1, 21, 30, 20)));
            carList.Add(new Car("Toyota", new DateTime(2019, 5, 1, 21, 30, 20), new DateTime(2011, 5, 1, 21, 30, 20), new DateTime(2014, 10, 1, 11, 30, 20)));

            return carList;
        }
    }

    public class Car : INotifyPropertyChanged
    {
        string m_make;
        DateTime m_planned_date;
        DateTime m_created_date;
        DateTime m_updated_date;
      
        public Car()
        {
        }

        public Car(string make, DateTime planned_date, DateTime created_date, DateTime updated_date)
        {
            this.Make = make;
            this.Planned_Date = planned_date;
            this.Created_Date = created_date;
            this.Updated_Date = updated_date;
        }

        public string Make
        {
            get { return m_make; }
            set
            {
                if (m_make != value)
                {
                    m_make = value;
                    OnPropertyChanged("Make");
                }
            }
        }

        public DateTime Planned_Date
        {
            get { return m_planned_date; }
            set
            {
                if (m_planned_date != value)
                {
                    m_planned_date = value;
                    OnPropertyChanged("Planned_Date");
                }
            }
        }

        public DateTime Created_Date
        {
            get { return m_created_date; }
            set
            {
                if (m_created_date != value)
                {
                    m_created_date = value;
                    OnPropertyChanged("Created_Date");
                }
            }
        }

        public DateTime Updated_Date
        {
            get { return m_updated_date; }
            set
            {
                if (m_updated_date != value)
                {
                    m_updated_date = value;
                    OnPropertyChanged("Updated_Date");
                }
            }
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        private void OnPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }
        #endregion
    }

}